#include <iostream>
using namespace std;
int main()
{
    long long int n, q, j;
    long long int kolicina = 0;
    long long int pojela = 0;
    cin >> n >> q;
    long long int d[n+1];
    long long int p[n];
    long long int k;
    d[0] = 0;
    for(long long int i = 0; i < n; i++)
    {
        cin >> d[i+1] >> p[i];
    }
    for(long long int i = 0; i < q; i++)
    {
        cin >> k;
        j = 1;
        while(d[j] <= k && j <= n)
        {
            pojela += d[j] - d[j-1];
            kolicina -= d[j] - d[j-1];
            if(kolicina < 0)
            {
                pojela += kolicina;
                kolicina = 0;
            }
            kolicina += p[j-1];
            j++;

        }
        pojela += k - d[j-1] + 1;
        kolicina -= k - d[j-1] + 1;
        if(kolicina < 0)
            pojela += kolicina;
        cout << pojela << endl;
        pojela = 0;
        kolicina = 0;
        j = 0;
    }
}